/*
 **	\file THREAD.h
 **	\date  2006-04-20
 **	\author grymse@alhem.net
**/
/*
Copyright (C) 2006  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _THREAD_H
#define _THREAD_H

#define INBUFSIZE 8192
#define OUTBUFSIZE 32000


typedef struct advstruct
{
	struct advstruct *next;
	int num;
	char descr[100];
	char author[80];
	char rating[20];
	char flags[20];
	char dir[40];
} ADV;

typedef struct eventstruct
{
	struct eventstruct *next;
	void *source;
	char text[200];
} EVENT;


class THREAD : public ParserIO
{
public:
	THREAD();
	virtual ~THREAD();
	int ioloop(char *,int *);
	int read_text(char *,int *);	// ParserIO callback method
	int write_text(char *,int ll = -1);
					// ParserIO callback method
	void echo_on();			// socket control (not used)
	void echo_off();		// socket control (not used)
	void add_event(char *s);	// node-node communication
	int catchup();			// node-node communication
	int get_adv();			// eol select adventure method

	// thread control
	THREAD *next;
	pthread_t thread;
	int running;			// thread keep-alive
	int socket;
	int ib,it,iq;
	int ob,ot,oq;
	char inbuf[INBUFSIZE];
	char outbuf[OUTBUFSIZE];

	// applesoft parser / eamon settings
	Parser cmdline;			// applesoft parse
	db::Account *account;		// db object: current account
	EVENT *current_event;		// current event pointer
	ADV *selected;			// selected eamon adventure disk
	int prompt_shown;
	int adjust_case;
	char last_print[1024];
	char prompt[200];		// last line of last_print
	char instr[1024];
};


#endif // _THREAD_H
